//INIZIO CODICE
//
//
//Inizio listato
//prodotto da calcola (antrec@geocities.com)//
//ver.4_1
//
//ATTENZIONE:
//
//CC BY-NC-SA 4.0
//Uso non commerciale, modificabile, con obbligo di condivisione-
//http://creativecommons.org/licenses/by-nc-sa/4.0/deed.it
//
/* Cosa fa:
Legge la tensione delle batterie su A0 e la usa per la commutazione enel/batterie con inverter UPS, al raggiungimento della tensione minima attende per un numero di secondi 
pari alla variabile config.pausa e poi controlla se le batterie sono ancora alla tensione minima, se si commuta su enel altrimenti resta a batterie; dopo la commutazione attiva
un relè per comandare un alimentatore di ricarica ausiliario. Sui pin A1 e A2 legge la
corrente del pannello e delle batterie, calcola la produzione ed il consumo istantanei, orari, giornalieri, memorizza i dati della produzione/consumo del giorno prima e di due
giorni prima. Permette di impostare le variabili preferenziali da momitor seriale senza dover ricaricare il listato, su monitor seriale trasmette anche alcune 
informazioni sul funzionamento.
Replica alcune informazioni su monitor LCD
//
*/
//
#include "OneWire.h"
#include "Wire.h"
#include "avr/eeprom.h"
#include "RTClib.h"
#include <avr/io.h>
#include <avr/wdt.h>
#define CONFIG_EEPROM_ADDR ((byte*) 0x10)
#include <LiquidCrystal_I2C.h>
RTC_DS1307 RTC;
LiquidCrystal_I2C lcd(0x27,20,4);

struct Config {
    float tensione_bassa;
    float tensione_alta;
    byte pausa;
    float coefficiente_conversione;
    float stop_ricarica;
    float ist;
    byte valid; //lasciare alla fine!
} config;

static void loadConfig() {
    for (byte i = 0; i < sizeof config; ++i)
        ((byte*) &config)[i] = eeprom_read_byte(CONFIG_EEPROM_ADDR + i);
        if (config.valid != 253) {
        config.valid = 253;
//
////////////////////////////////
//INIZIO PARTE MODIFICABILE
///////////////////////////////
        
        config.coefficiente_conversione = 0.0552; //arrotondare alla 4.a cifra decimale
        config.tensione_bassa = 11.9;      //valori: 11.9 (sistema 12V); 23.8 (sistema 24V)
        config.tensione_alta = 13.7;      //valori: 13.7 (sistema 12V); 27.4 (sistema 24V)
        config.pausa = 8;                //ritardo in secondi per compensare brevi abbassamenti di tensione
        config.stop_ricarica = 25.5;      //tensione fine ricarica
        config.ist = 0.5;               //isteresi ricarica
///////////////////////////////
//FINE PARTE MODIFICABILE
///////////////////////////////
//        
        }
        }

    static void saveConfig() {
    for (byte i = 0; i < sizeof config; ++i)
        eeprom_write_byte(CONFIG_EEPROM_ADDR + i, ((unsigned char*) &config)[i]);        
}
OneWire  ds(3); //Setto come pin per la onewire (pwm!!!)
int rit;
int c;
unsigned long a;
unsigned long b;
byte min_avvio;//tempo avvio
byte min_avvio_ora;//tempo avvio conto secondi per media oraria
byte min_adesso;//tempo per il campionamento
byte min_lett_ora;//tempo avvio conto secondi per calcolo somma produzione
byte sec_adesso;
byte ora_adesso;
int n_letture = 0;//numero letture istantanee

#define inputPin1 (A2) //sensore corrente pannello
#define inputPin2 (A3) //sensore corrente batterie
#define RELAY1 4 //led verde + relè commutazione. Indicatore stato batterie
#define RELAY2 5 //led rosso. Indicatore stato rete.
#define RICARICA 9 //Ricarica batterie
#define inputPin (A0) //Sensore tensione collegato al pin analogico 0
#define numero_letture 5 //Il numero indica i valori tensione da leggere

#define bassatensione (config.tensione_bassa/config.coefficiente_conversione) // Valore numerico della tensione stop batt ritorno rete
#define altatensione (config.tensione_alta/config.coefficiente_conversione) // Valore numerico tensione stop rete passo batt.
#define media1 (bassatensione + altatensione)/2 // Media tensione per avvio numero
#define media_avvio media1*config.coefficiente_conversione // media1 in Volt

int readings[numero_letture]; //Letture da ingresso analogico
int index = 0; //Indice della lettura corrente
int total = 0; //Totale letture
int media_tens = 0; //Media tensione indice analogico
float media_tens_volt; //media tensione espressa in Volt
byte enel0 = 0;
byte stato = 0;
byte carica = 0;
float correntebatt = 0; //media corrente singola lettura
float correntepan = 0; //media corrente singola lettura
float correntepansom = 0;// somma corrente pannello un campionamento al minuto
float correntebattsom = 0;//somma corrente batterie un campionamento al minuto
float corr_pro_pan = 0; //corrente prodotta pannello giorno in corso
float corr_pro_bat = 0; //bilancio corrente in batteria giorno in corso
float corr_ba_med = 0; //media corrente oraria batteria
float corr_pa_med = 0; //media corrente oraria pannello
float corr_prod_p_i = 0; //corrente prodotta pannello giorno precedente
float corr_prod_b_i = 0; //bilancio corrente batteria giorno precedente




  
void setup()
{
//Apro la comunicazion seriale
Serial.begin(9600);
lcd.init();                      // apro LCD
lcd.backlight();
Wire.begin();
 DateTime now = RTC.now();
 min_avvio = (now.minute());
 min_avvio_ora = min_avvio;
  
pinMode(RELAY1, OUTPUT);
pinMode(RELAY2, OUTPUT);
pinMode(RICARICA, OUTPUT);
pinMode(inputPin, INPUT);
loadConfig();

if (! RTC.isrunning()) {
    // following line sets the RTC to the date & time this sketch was compiled
    RTC.adjust(DateTime(__DATE__, __TIME__));
   }

wdt_enable(WDTO_8S);  //abilito il watchdog e imposto come tempo di reset 8 secondi

{if (analogRead(inputPin) > media1){batterie();}
else{enel();}}

for (int i = 0; i < numero_letture; i++)
readings[i] = 0; //Mette tutti 0 nell'array

for (int s = 0; s < 40; s++)
readings[s] = 0; //Mette tutti 0 nell'array
}

void loop(){

  tensione();
  sensore_corrente();
  ricarica();
if (Serial.available() > 0){ immissione();}
if ((media_tens_volt < config.tensione_bassa) && (enel0 !=1) && (stato !=1))
{ritardo();}
  if (stato ==1){b=millis(); if ((b-a>rit)&&(media_tens_volt < config.tensione_bassa)){enel();}}
  if(media_tens_volt > config.tensione_alta){batterie();}
  if (enel0 == 0) {Serial.println("Stato: batterie");}
  else if ((enel0 == 1) && (carica==0)){Serial.println(" Stato: enel");}
  else if ((enel0 == 1) && (carica==1)){Serial.println(" Stato: enel + ricarica");}

DateTime now = RTC.now();
Serial.print(" Ora: ");
Serial.print(now.hour());
Serial.print(":");
Serial.print(now.minute());
Serial.print(":");
Serial.println(now.second());
Serial.print(" Tensione batteria intermedio tra min-max: ");
Serial.println(media_avvio);
Serial.println("-----------");
Serial.print(" Tensione batteria (media 5 letture): ");
Serial.println(media_tens_volt); //Serial.println(media_tens);
Serial.print(" Passa a enel quando minore di: ");
Serial.println(config.tensione_bassa);
Serial.print(" Passa a batterie quando maggiore di: ");
Serial.println(config.tensione_alta);
//Serial.println("-----------");
Serial.print(" Tensione limite ricarica: ");
Serial.println(config.stop_ricarica);
Serial.print(" Isteresi ricarica: ");
Serial.println(config.ist);
Serial.print(" Coefficiente di conversione: ");
Serial.println(config.coefficiente_conversione,4);
Serial.println("-----------");
Serial.print(" Ritardo commutazione: ");
Serial.println(config.pausa);
Serial.println("-----------");
Serial.print(" Corrente istantanea pannello (A): ");
Serial.println(correntepan);
Serial.print(" Media oraria corrente pannello (Ah): ");
Serial.println(corr_pa_med);
Serial.print(" Corrente totale pannello (Ah): ");
Serial.println(corr_pro_pan);
Serial.println("-----------");
Serial.print(" Corrente istantanea batterie (A): ");
Serial.println(correntebatt);
Serial.print(" Media oraria corrente batterie (Ah): ");
Serial.println(corr_ba_med);
Serial.print(" Corrente totale batterie (Ah): ");
Serial.println(corr_pro_bat);
Serial.println("-----------");
Serial.print(" Produzione totale pannello ieri (Ah): ");
Serial.println(corr_prod_p_i);
Serial.print(" Produzione totale batterie ieri (Ah): ");
Serial.println(corr_prod_b_i);

//Serial.println("-----------");
Serial.println("v: 4_1");
lcd.clear();
if (enel0 == 0 ){lcd.setCursor(0,0);
lcd.print("Batteria");}
if ((enel0 == 1) && (carica !=1)){ lcd.print("Enel");}
if ((enel0 == 1)&& (carica == 1)){ lcd.print("Enel + ricarica");}
lcd.setCursor(0,1);
lcd.print("Tens:  "); lcd.print(media_tens_volt, 2);
delay (2000);
lcd.setCursor(0,0);lcd.print("                ");
lcd.setCursor(0,0);lcd.print("P:"); lcd.print(correntepan,1);
lcd.setCursor(7,0);
lcd.print("  B:"); lcd.print(correntebatt,1);

//Serial.print("Millis iniziali; ");
//Serial.println(a);
//Serial.print("Millis finali: ");
//Serial.println(b);
Serial.println("-----------");
//Serial.println(carica);

riavvio();
}

void tensione(){
 
for (int i = 0; i < numero_letture; i++){
total -= readings[index]; //Sottrae l'ultima lettura
readings[index] = analogRead(inputPin); //Legge i valori provenienti dal sensore e li salva nell'array
total += readings[index]; //Aggiunge la lettura al totale
index = (index + 1); //Incrementa l'indice

if (index >= numero_letture)
index = 0; //Alla fine dell'array resetta l'indice a 0

media_tens = total / numero_letture; //Calcola la media
}
media_tens_volt = media_tens * config.coefficiente_conversione;

}

void sensore_corrente(){
 
  for(int s = 0; s < 40; s++) {
  correntepan = correntepan + ((0.245 * analogRead(inputPin1)) - 124.87); //pannello sensore ACS758-100B (0,245 125  0,01718)
  correntebatt = correntebatt + ((0.49 * analogRead(inputPin2)) - 250.16);  //batterie sensore ACS758-200B  (0,49 250)  
  }
 
 correntepan=correntepan/40;
 correntebatt=correntebatt/40;
 
 DateTime now = RTC.now();
 min_adesso = (now.minute());
 min_lett_ora = (now.minute());
 sec_adesso = (now.second());
 ora_adesso=(now.hour());
 
if (min_avvio == 59 && sec_adesso == 59){min_avvio = 0;}  
 if (min_adesso == min_avvio + 1){n_letture = n_letture + 1;  
     correntebattsom = (correntebattsom + correntebatt);  
     correntepansom = (correntepansom + correntepan);  
     corr_ba_med = correntebattsom / n_letture;  
     corr_pa_med = correntepansom / n_letture;
     min_avvio = min_adesso;}
 if (min_avvio_ora == 0){min_avvio_ora = 59;}
 if ((min_lett_ora == min_avvio_ora - 1)&&(sec_adesso == 59)) {
     corr_pro_bat = corr_pro_bat + corr_ba_med; corr_pro_pan = corr_pro_pan + corr_pa_med;
     correntepansom = 0; correntebattsom = 0; n_letture = 0; min_avvio_ora = min_lett_ora;}
 if  (ora_adesso == 0 && min_adesso == 0){corr_prod_b_i = corr_pro_bat; corr_prod_p_i = corr_pro_pan;}
 if  (ora_adesso == 0 && min_adesso == 1){corr_pro_pan = 0; corr_pro_bat = 0; 
      n_letture = 0;corr_ba_med = 0; corr_pa_med = 0; correntepansom = 0;correntebattsom = 0;}
      
}

void enel() {
digitalWrite(RELAY2, HIGH);
delay(200);
digitalWrite(RELAY1, LOW);
a=b;
enel0 = 1;
stato = 2 ;
}

void batterie(){
  digitalWrite(RELAY1, HIGH);
delay(200);
digitalWrite(RELAY2, LOW);
a=b;
enel0 = 0;
stato = 2 ;
}

void ricarica(){
  if ((config.stop_ricarica > media_tens_volt) && (enel0 == 1)){(digitalWrite(RICARICA, HIGH)); carica = 1;}
  if ((enel0 == 1) && ((config.stop_ricarica -config.ist) < media_tens_volt)){(carica = 0);(digitalWrite(RICARICA, LOW));}
  }

void ritardo(){
rit = config.pausa*1000;
a= millis();
stato = 1;
}

void immissione(){
 c= Serial.findUntil("soglie", "soglie");
 if (c == 1){svuotabuffer(); c = 0;
 loadConfig();
 
Serial.print("Tensione commutazione enel: ");
delay(4000); wdt_reset();
if (Serial.available() > 0){config.tensione_bassa = Serial.parseFloat(); svuotabuffer();}
wdt_reset(); Serial.println(config.tensione_bassa);
Serial.println("");

Serial.print("Tensione commutazione batterie: ");
delay(4000); wdt_reset();
if (Serial.available() > 0){ config.tensione_alta = Serial.parseFloat(); svuotabuffer();}
Serial.println(config.tensione_alta);
Serial.println("");

Serial.print("Tensione fine ricarica: ");
delay(4000); wdt_reset();
if (Serial.available() > 0){ config.stop_ricarica = Serial.parseFloat();svuotabuffer();}
Serial.println(config.stop_ricarica);
Serial.println("");

Serial.print("Isteresi ricarica: ");
delay(4000); wdt_reset(); 
if (Serial.available() > 0){ config.ist = Serial.parseFloat(); svuotabuffer();}
Serial.println(config.ist);
Serial.println("");

Serial.print("Coefficiente di conversione: ");
delay(4000); wdt_reset();
if (Serial.available() > 0){ config.coefficiente_conversione = Serial.parseFloat(); svuotabuffer();}
wdt_reset(); Serial.println(config.coefficiente_conversione,4);
Serial.println("");

Serial.print("Secondi ritardo commutazione: ");
delay(4000); wdt_reset();
if (Serial.available() > 0){ config.pausa = Serial.parseFloat();svuotabuffer();}
wdt_reset(); Serial.println(config.pausa);
Serial.println("");

saveConfig();

}

else Serial.println("Errore, ripeti");
delay(2000);}

void svuotabuffer() {
  while (Serial.available()) {
    byte temp = Serial.read();
  }
}

void riavvio()
{
wdt_reset(); //resetto il watchdog
Serial.println("azzerato");
}
//Fine listato
